<!DOCTYPE html>
<html>
  <head>
    <title>larp.io/Scan and Redirect</title>
    <script type="text/javascript" src="instascan.min.js"></script>
    <link rel="stylesheet" type="text/css" href="styles/main.css">
  </head>
  <body>
    <video id="preview"></video>

    <div class="box">
      <p id="message">Prêt à scanner</p>
    </div>

    <script type="text/javascript">
      let scanner = new Instascan.Scanner({ video: document.getElementById('preview') });
      scanner.addListener('scan', function (content) {
        const URL_SEPARATOR = '/';

        //REGION CONFIG

        const OPEN_RESULT_IN_NEW_TAB = false;
        const OPEN_RESSOURCE_FROM_SAME_FOLDER = true;
        //const RESULT_MATCH_FILTER = "^https:\/\/www\.google\.com";
        const RESULT_PREFIX = "indices/"
        const RESULT_SUFIX = ".html"
        //const TEST_TARGET_EXIST_BEFORE_REDIRECT = true;
        const MILS_BEFORE_REDIRECT = 2000;

        //ENDREGION CONFIG

        var redirectPath;
        document.getElementById('message').innerText = "Code scanné, redirection en cours";

        if(!(typeof RESULT_MATCH_FILTER === 'undefined') && RESULT_MATCH_FILTER) {
          var regExp = new RegExp(RESULT_MATCH_FILTER);
          if(!regExp.test(content)) {
            document.getElementById('message').innerText = "Le code scanné ne correspond pas au filtre";
            setTimeout(function(){
              document.getElementById('message').innerText = "Prêt à scanner";
            }, MILS_BEFORE_REDIRECT);
            return;
          }
        }

        if(!(typeof OPEN_RESSOURCE_FROM_SAME_FOLDER === 'undefined') && OPEN_RESSOURCE_FROM_SAME_FOLDER)
        {
          let currentUrlArray = window.location.href.split(URL_SEPARATOR);
          currentUrlArray.pop();
          redirectPath = currentUrlArray.join(URL_SEPARATOR) + URL_SEPARATOR;
        }

        if(!(typeof RESULT_PREFIX === 'undefined') && RESULT_PREFIX) {
          content = RESULT_PREFIX + content;
        }

        if(!(typeof RESULT_SUFIX === 'undefined') && RESULT_SUFIX) {
          content = content + RESULT_SUFIX;
        }

        if(typeof redirectPath === 'undefined') {
          redirectPath = content;
        } else {
          redirectPath = redirectPath + content;
        }

        //blocked by cors ?
        if(!(typeof TEST_TARGET_EXIST_BEFORE_REDIRECT === 'undefined') && TEST_TARGET_EXIST_BEFORE_REDIRECT) {
          var MrChecker = new XMLHttpRequest(),
              CheckThisUrl = redirectPath;

          MrChecker.open('get', CheckThisUrl, true);

          MrChecker.onreadystatechange = checkReadyState;

          function checkReadyState() {
              if (MrChecker.readyState === 4) {
                  //check to see whether request for the file failed or succeeded
                  if (!((MrChecker.status == 200) || (MrChecker.status == 0))) {                
                    document.getElementById('message').innerText = "Le code scanné ne correspond pas à une ressource existante";
                    setTimeout(function(){
                      document.getElementById('message').innerText = "Prêt à scanner";
                    }, MILS_BEFORE_REDIRECT);
                    return;
                  }
              }
          }
          MrChecker.send(null);
        }

        setTimeout(function(){
          if(!(typeof OPEN_RESULT_IN_NEW_TAB === 'undefined') && OPEN_RESULT_IN_NEW_TAB) {
            //Redirection dans un nouvel onglet
            Object.assign(document.createElement('a'), { target: '_blank', href: redirectPath}).click();
          } else {
            //Redirection fenètre courante
            window.location.replace(redirectPath);
          }
        }, MILS_BEFORE_REDIRECT);
      });
      Instascan.Camera.getCameras().then(function (cameras) {
        if (cameras.length > 0) {
          scanner.start(cameras[0]);
        } else {
          console.error('No cameras found.');
        }
      }).catch(function (e) {
        console.error(e);
      });
    </script>
  </body>
</html>